// --- commodity log ------------------------------------------------------------------------

function info(msg) {
	if ( window.console ) 
		window.console.info(msg);
}

// --- ajax --------------------------------------------------------------------------

var trovo_un_modo_per_considerare_i_parametri = true;

function inizializzaStart() {
	if ( ! trovo_un_modo_per_considerare_i_parametri ) 
		return 0;
	else {
		var fields = document.getElementsByTagName('form')[0].childNodes;
		for ( var i = 0 ; i < fields.length ; i++ ) {
			try {
				if ( fields[i].name == "postId")
					return parseInt( fields[i].value );
			} catch(e) { }
		}
	}
}

function inizializzaStop(start,posts) {
	if ( ! trovo_un_modo_per_considerare_i_parametri ) 
		return posts.length;
	else {
		var numberOfPosts = posts.length;
		var fields = document.getElementsByTagName('form')[0].childNodes;
		for ( var i = 0 ; i < fields.length ; i++ ) {
			try {
			if ( fields[i].name == "numberOfPosts")
				numberOfPosts = parseInt( fields[i].value );
			} catch(e) { }
		}
		var lastPost = start + numberOfPosts;
		info("Last post asked by user = " + lastPost + "; total number of posts = " + posts.length);
		if ( lastPost > posts.length )
			return posts.length;
		else
			return lastPost;
	}
}

function leggiContenuto(item, nomeNodo) {
	return item.getElementsByTagName(nomeNodo).item(0).firstChild.nodeValue;
};


function applicaContenuto( theXML, theElement ) {
	var theHTML = 
		"<p>" +
			"<ul>";
	
	var posts = theXML.getElementsByTagName("post");
	
	// Predisponiamo una struttura dati in cui memorrizzare le informazioni di interesse
	var itemNodes = new Array();

	// ciclo di lettura degli elementi
	
	var start = inizializzaStart();
	var stop = inizializzaStop(start,posts);
	
	for ( var i = 0, p = start;    p < stop;   i++, p++   ) {
		// [length al posto di push serve per evitare errori con vecchi browser]
		itemNodes[i] = new Object();
		itemNodes[i].testo = leggiContenuto(posts[p],"testo");
		itemNodes[i].giorno = leggiContenuto(posts[p],"giorno");
		itemNodes[i].ora = leggiContenuto(posts[p],"ora");

	}// for ( items )

	if ( itemNodes.length > 0 ) {
		for( var c = 0; c < itemNodes.length; c++ ) {
			theHTML += '<li>'+itemNodes[c].giorno+', '+itemNodes[c].ora+' = '+itemNodes[c].testo+'</li>';
		};
	}
	else {
		theHTML += "Spiacente: nessun post corrisponde ai criteri inseriti.<br/>";
		theHTML += "(sono disponibili post con id compresi tra 0 e " + posts.length + ")"
	}

	theHTML += "</ul></p>";
	theElement.innerHTML = theHTML;
}

/*
 * Funzione di callback
 */
function callback( theXhr, theElement ) {

	// designiamo la formattazione della zona dell'output
	theElement.class = "content";
	
	// verifica dello stato
	if ( theXhr.readyState === 2 ) {
	    	theElement.innerHTML = "Richiesta inviata...";
	}// if 2
	else if ( theXhr.readyState === 3 ) {
    		theElement.innerHTML = "Ricezione della risposta...";
	}// if 3
	else if ( theXhr.readyState === 4 ) {

		// verifica della risposta da parte del server
	        if ( theXhr.status === 200 ) {

	        	// operazione avvenuta con successo
			if ( theXhr.responseXML ) {
		        applicaContenuto(theXhr.responseXML, theElement);
			}// if XML

			else {
			        // visualizzazione contenuto letto
			        // evitando di scrivere la risposta in modo
			        // interpretabile dal browser
        			theElement.innerHTML = "L'XML restituito dalla richiesta non è valido.<br />" +
        			theXhr.responseText.split('<').join("&lt;").split('>').join("&gt;");
			}// else (if ! XML)

	        }// if 200

	        else {
	        	// errore di caricamento
	        	theElement.innerHTML = "Impossibile effettuare l'operazione richiesta.<br />";
	        	theElement.innerHTML += "Errore riscontrato: " + theXhr.statusText;
	        }// else (if ! 200)

	}// if 4

} // callback();




/*
 * Imposta il contenuto xml disponibile presso theUri
 * all'interno dell'elemento theHolder del DOM
 * Usa tecniche AJAX attrverso la XmlHttpRequest fornita in theXhr
 */
function caricaContenutoAJAX(theUri, theElement, theXhr) {
    
	// impostazione controllo e stato della richiesta
	theXhr.onreadystatechange = function() { callback(theXhr, theElement); };

	// impostazione richiesta asincrona in POST!!
	// del file specificato
	try {
		theXhr.open("get", theUri, true);
	}
	catch(e) {
		// Exceptions are raised when trying to access cross-domain URIs 
		alert(e);
	}

	// rimozione dell'header "connection" come "keep alive"
	theXhr.setRequestHeader("connection", "close");

	// invio richiesta
	theXhr.send(null);
	
} // caricaContenutoAJAX()



/*
 * Imposta il contenuto disponibile presso theUri
 * come src di un iframe all'interno dell'elemento theHolder del DOM
 * Non usa AJAX; per browser legacy
 */
function caricaContenutoIframe(theUri,theHolder) {
	// qui faccio scaricare al browser direttamente il contenuto del feed come src dell'iframe.
	theHolder.innerHTML = '<iframe src="' + theUri + '" width="50%" height="50px">Il tuo browser non supporta gli iframe</iframe>';
	// non riesco tuttavia a intervenire per parsarlo! è il browser che renderizza l'src dell'iframe!
}// caricaContenutoIframe()



/*
 * Scarica un contenuto xml dall'uri fornito
 * e lo aggiunge al contenuto dell'elemento e del dom
 * Gestisce sia AJAX che il mancato supporto ad AJAX 
 */
function caricaContenuto(uri,e) {

	// variabili di funzione
	var
		// assegnazione oggetto XMLHttpRequest
		xhr = myGetXmlHttpRequest();

	if ( xhr ) 
		caricaContenutoAJAX(uri,e,xhr); 
	else 
		caricaContenutoIframe(uri,e); 

}// caricaContenuto()




function carica() {
	var fields = document.getElementsByTagName('form')[0].childNodes;
	var id, number;
	for ( var i = 0 ; i < fields.length ; i++ ) {
		try {
			if ( fields[i].name == "numberOfPosts")
				number = fields[i].value;
			if ( fields[i].name == "postId")
				id = fields[i].value;
		} catch(e) { }
	}
	var uri = "posts.xml?id="+id+"&number="+number;
	var target = myGetElementById("result");
	caricaContenuto(uri,target);
}